//
//  FlipsideViewController.m
//  ex_UtilityAppTemplate-2
//
//  Created by yoshiyuki oshige on 2013/09/04.
//  Copyright (c) 2013年 yoshiyuki. All rights reserved.
//

#import "FlipsideViewController.h"

@interface FlipsideViewController ()
{
    //設定値を保存する辞書
    NSMutableDictionary *flipsideDic;
}
//UI部品とアウトレット接続してプロパティ宣言しておきます
@property (weak, nonatomic) IBOutlet UITextField *messageText;
@property (weak, nonatomic) IBOutlet UIDatePicker *datePicker;
@property (weak, nonatomic) IBOutlet UISwitch *imageSwitch;
//画面のタップアクションのメソッド宣言
- (IBAction)tapView:(UITapGestureRecognizer *)sender;
//flipsideDicの設定値でビューを更新するメソッド
- (void)configureView;
@end

@implementation FlipsideViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    

}

//ビューが表示される前に画面を更新する
- (void)viewWillAppear:(BOOL)animated
{
    //ビューをflipsideDicの設定値で更新する
    [self configureView];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Actions

//Doneボタンで実行する
- (IBAction)done:(id)sender
{
    //現在の設定をflipsideDicに保管する
    flipsideDic[@"user"] = _messageText.text;
    flipsideDic[@"date"] = _datePicker.date;
    flipsideDic[@"switch"] = @(_imageSwitch.on);
    //デリゲートのMainviewControllerにデリゲートメソッドを送り、flipsideDicを受け渡す
    [self.delegate flipsideViewControllerDidFinish:self
                                         configDic:(NSMutableDictionary *)flipsideDic];
}

//画面タップでキーボードを下げる
- (IBAction)tapView:(UITapGestureRecognizer *)sender {
    [self.view endEditing:YES];
}

//Flipside View Controllerシーンを開く
- (void)setConfigureDic:(NSMutableDictionary *)configDic
{
    if(flipsideDic == nil){
        flipsideDic = [NSMutableDictionary dictionary];
    }
    //引数で受けたmainviewDicの値でflipsideDicを更新する
    [flipsideDic addEntriesFromDictionary:configDic];
}

//flipsideDicの設定値でビューを更新する
- (void)configureView
{
    //メッセージ文
    _messageText.text = flipsideDic[@"user"];
    //デートピッカー
    _datePicker.date = flipsideDic[@"date"];
    //スイッチ
    _imageSwitch.on = [flipsideDic[@"switch"] boolValue];
}
@end
