//
//  MainViewController.m
//  ex_UtilityAppTemplate-2
//
//  Created by yoshiyuki oshige on 2013/09/04.
//  Copyright (c) 2013年 yoshiyuki. All rights reserved.
//

#import "MainViewController.h"

@interface MainViewController ()
{
    //設定値を保存する辞書
    NSMutableDictionary *mainviewDic;
}

//UI部品とアウトレット接続してプロパティ宣言しておきます
@property (weak, nonatomic) IBOutlet UILabel *messageLabel;
@property (weak, nonatomic) IBOutlet UILabel *dateLabel;
@property (weak, nonatomic) IBOutlet UIImageView *myImage;

//mainviewDicの設定値でビューを更新するメソッド
- (void)configureView;
@end

@implementation MainViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    //初期値の設定
    mainviewDic = [NSMutableDictionary dictionary];
    mainviewDic[@"user"] = @"未設定";
    mainviewDic[@"date"] = [NSDate date];
    mainviewDic[@"switch"] = @YES;
}

//ビューが表示される前に画面を更新する
- (void)viewWillAppear:(BOOL)animated
{
    //ビューをmainviewDicの設定値で更新する
    [self configureView];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Flipside View

//Flipsideシーンから戻るためのFlipsideViewControlerDelegateデリゲートメソッド
- (void)flipsideViewControllerDidFinish:(FlipsideViewController *)controller
                              configDic:(NSMutableDictionary *)configDic
{
    //Flipsideシーンからのデータの受け渡し
    if(mainviewDic == nil){
        mainviewDic = [NSMutableDictionary dictionaryWithCapacity:3];
    }
    //引数で受けたflipsideDicの値をmainviewDicに受け渡す
    [mainviewDic addEntriesFromDictionary:configDic];
    
    //Flipsideシーンを閉じてMainシーンを開く
    [self dismissViewControllerAnimated:YES completion:nil];
}

//Flipside View Controllerシーンに移動する直前に実行されるメソッド
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    if ([[segue identifier] isEqualToString:@"showAlternate"]) {
        [[segue destinationViewController] setDelegate:self];
        //FlipsideViewControllerにデータを送る
        [[segue destinationViewController] setConfigureDic:mainviewDic];
    }
}

//ビューをmainviewDicの設定値で更新する
- (void)configureView
{
    //メッセージ文
    _messageLabel.text = [NSString stringWithFormat:@"こんにちは、%@さん", mainviewDic[@"user"]];
    //日時
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat:@"yyyy年MM月dd日 HH:mm"];
    _dateLabel.text = [formatter stringFromDate:mainviewDic[@"date"]];
    //イラストの表示／非表示
    _myImage.hidden = ![mainviewDic[@"switch"] boolValue];
}

@end
